import sys
sys.setrecursionlimit(400000)
line = input()
n = int(line.split()[0])
q = int(line.split()[1])

g = [[] for i in range(n)]
turn = [0 for i in range(n)]

line = input()
tree = [int(i) for i in line.split()]

for i in range(n-1):
  v = tree[i]
  g[i+1] += [v]
  g[v] += [i+1]

# reduce the paths
for i in range(1, n):
  if len(g[i]) == 2 and len(g[g[i][0]]) == 2 and len(g[g[i][1]]) == 2:
    a = g[i][0]
    b = g[i][1]
    g[a][g[a].index(i)] = b
    g[b][g[b].index(i)] = a



def dfs(v, parent):
  global turn
  if len(g[v]) <= 1 and v != 0:
    return v

  if g[v][turn[v]] == parent:
    turn[v] += 1
    turn[v] %= len(g[v])
    cur = g[v][turn[v]]

  res = dfs(g[v][turn[v]], v)
  turn[v] += 1
  turn[v] %= len(g[v])

  return res


for i in range(q):
  if n == 1:
    print(0)
  else:
    print(dfs(0, -1))
