#include <bits/stdc++.h>
using namespace std;
using ll=long long;
using ld=double;
#define FOR(i,a,b) for(ll i=a;i<(ll)b;++i)
#define F(n) FOR(i,0,n)
#define FF(n) FOR(j,0,n)
#define aa first
#define bb second
#define PB push_back
#define EQ(a,b) (fabs(a-b)<=(fabs(a+b)*EPS))
#define MOD ((ll)(1e9+7))

vector<vector<ll>> g;
vector<ll> res;
vector<ll> turn;

void dfs(int v, int par, int id) {
  if (v != 0 && g[v].size() == 1) {
    res[id] = v;
    return;
  }

  if (g[v][turn[v]] == par) turn[v] ++;
  turn[v] %= g[v].size();

  dfs(g[v][turn[v]], v, id);

  turn[v] ++;
  turn[v] %= g[v].size();
}

int main(){
  ios::sync_with_stdio(0);cin.tie(0);
  ll n, q;
  cin >> n >> q;
  g = vector<vector<ll>>(n);
  res = vector<ll>(q);
  turn = vector<ll>(n);

  F(n-1) {
    ll t;
    cin >> t;
    g[i+1].PB(t);
    g[t].PB(i+1);
  }

  // reduce long paths
  for (int i = 1; i < n; ++ i)
    if (g[i].size() == 2
        && g[g[i][0]].size() == 2
        && g[g[i][1]].size() == 2) {
      const int u = g[i][0];
      const int v = g[i][1];
      for (int j = 0; j < 2; ++ j) if (g[u][j] == i) g[u][j] = v;
      for (int j = 0; j < 2; ++ j) if (g[v][j] == i) g[v][j] = u;
    }

  if (n >= 2)
    F(q) dfs(0, -1, i);

  for (auto i: res) cout << i << '\n';

  return 0;
}
